# Plant Class Reference

`#include <plant.h>`

Inheritance diagram for Plant:

List of all members.

## Public Member Functions

| Plant ()
void | calc_bounding_rect () const
virtual bool | set_param (const String &param, const synfig::ValueBase &value)
| Sets the parameter described by param to value.
virtual ValueBase | get_param (const String &param) const
| Get the value of the specified parameter.
virtual bool | set_version (const synfig::String &ver)
| Sets the virtual version to use for backwards-compatibility.
virtual Vocab | get_param_vocab () const
| Gets the parameter vocabulary.
virtual bool | accelerated_render (synfig::Context context, synfig::Surface *surface, int quality, const synfig::RendDesc &renddesc, synfig::ProgressCallback *cb) const
| Renders the Canvas to the given Surface in an accelerated manner.
virtual synfig::Rect | get_bounding_rect (synfig::Context context) const

## Classes

struct | Particle

## Constructor & Destructor Documentation

Plant::Plant | ( |  | ) |

References f, Random::set_seed(), and zero().

## Member Function Documentation

void Plant::calc_bounding_rect | ( |  | ) | const

References synfig::Rect::expand(), synfig::Rect::expand_x(), synfig::Rect::expand_y(), and zero().

bool Plant::set_param | ( | const String & | param,
|  | const synfig::ValueBase & | value |
| ) |  |  | `[virtual]`

Sets the parameter described by param to value.

Parameters:

  | param | The name of the parameter to set
  | value | What the parameter is to be set to.

Returns:
  `true` on success, `false` upon rejection or failure. If it returns `false`, then the Layer is assumed to remain unchanged.

See also:
  get_param()

Todo:
  param should be of the type `const String &param`

Reimplemented from synfig::Layer_Composite.

References synfig::ValueBase::get(), synfig::ValueBase::get_loop(), synfig::ValueBase::get_type(), IMPORT, IMPORT_AS, IMPORT_PLUS, synfig::ValueBase::same_type_as(), and Random::set_seed().

ValueBase Plant::get_param | ( | const String & | param | ) | const`[virtual]`

Get the value of the specified parameter.

Returns:
  The requested parameter value, or (upon failure) a NIL ValueBase.

See also:
  set_param()

Todo:
  param should be of the type `const String &`

Reimplemented from synfig::Layer_Composite.

References EXPORT, EXPORT_NAME, and Random::get_seed().

bool Plant::set_version | ( | const synfig::String & | ver | ) | `[virtual]`

Sets the virtual version to use for backwards-compatibility.

See also:
  reset_version()

Reimplemented from synfig::Layer.

Layer::Vocab Plant::get_param_vocab | ( | void |  | ) | const`[virtual]`

Gets the parameter vocabulary.

Reimplemented from synfig::Layer_Composite.

References _, and synfig::Layer::set_description().

bool Plant::accelerated_render | ( | synfig::Context | context,
|  | synfig::Surface * | surface,
|  | int | quality,
|  | const synfig::RendDesc & | renddesc,
|  | synfig::ProgressCallback * | cb |
| ) |  |  | const`[virtual]`

Renders the Canvas to the given Surface in an accelerated manner.

Parameters:

  | context | Context iterator referring to next Layer.
  | surface | Pointer to Surface to render to.
  | quality | The requested quality-level to render at.
  | renddesc | The associated RendDesc.
  | cb | Pointer to callback object. May be NULL if there is no callback.

Returns:
  `true` on success, `false` on failure

See also:
  Handle::accelerated_render()

Reimplemented from synfig::Layer_Composite.

References std::abs(), synfig::Context::accelerated_render(), synfig::Surface::blit_to(), synfig::Surface::clear(), synfig::Color::get_a(), synfig::Layer_Composite::get_amount(), synfig::Layer_Composite::get_blend_method(), synfig::RendDesc::get_br(), synfig::RendDesc::get_h(), synfig::RendDesc::get_tl(), synfig::RendDesc::get_w(), synfig::Layer_Composite::is_disabled(), and synfig::Color::set_a().

Rect Plant::get_bounding_rect | ( | synfig::Context | context | ) | const`[virtual]`

References synfig::Layer_Composite::get_blend_method(), synfig::Context::get_full_bounding_rect(), synfig::Layer_Composite::is_disabled(), and zero().

The documentation for this class was generated from the following files:

- plant.h
- plant.cpp